summaryrefslogtreecommitdiff
path: root/tests/basic
blob: bcade42efead44942cdd5eec2303a8afcec9068e (plain)
  1. #!/usr/bin/env bash
  2. # Tests to ensure that the monkeysphere is working
  3. # Authors:
  4. # Daniel Kahn Gillmor <dkg@fifthhorseman.net>
  5. # Jameson Rollins <jrollins@fifthhorseman.net>
  6. # Micah Anderson <micah@riseup.net>
  7. #
  8. # Copyright: 2008-2009
  9. # License: GPL v3 or later
  10. # these tests should all be able to run as a non-privileged user.
  11. # all subcommands in this script should complete without failure:
  12. set -e
  13. # piped commands should return the code of the first non-zero return
  14. set -o pipefail
  15. # make sure the TESTDIR is an absolute path, not a relative one.
  16. export TESTDIR=$(cd $(dirname "$0") && pwd)
  17. source "$TESTDIR"/common
  18. ## make sure that the right tools are installed to run the test. the
  19. ## test has *more* requirements than plain ol' monkeysphere:
  20. which socat >/dev/null || { echo "You must have socat installed to run this test." ; exit 1; }
  21. ## FIXME: other checks?
  22. ######################################################################
  23. ### FUNCTIONS
  24. # gpg command for test admin user
  25. gpgadmin() {
  26. chmod 0700 "$TEMPDIR"/admin
  27. GNUPGHOME="$TEMPDIR"/admin/.gnupg gpg "$@"
  28. }
  29. # test ssh connection
  30. # first argument is expected return code from ssh connection
  31. ssh_test() {
  32. umask 0077
  33. CODE=${1:-0}
  34. # start the ssh daemon on the socket
  35. echo "##### starting ssh server..."
  36. socat EXEC:"/usr/sbin/sshd -f ${SSHD_CONFIG} -i -D -e" "UNIX-LISTEN:${SOCKET}" 2> "$TEMPDIR"/sshd.log &
  37. SSHD_PID="$!"
  38. # wait until the socket is created before continuing
  39. while [ ! -S "$SOCKET" ] ; do
  40. sleep 1
  41. done
  42. set +e
  43. # make a client connection to the socket
  44. echo "##### starting ssh client..."
  45. ssh-agent bash -c \
  46. "monkeysphere subkey-to-ssh-agent && ssh -F $TEMPDIR/testuser/.ssh/config testhost true"
  47. RETURN="$?"
  48. # kill the sshd process if it's still running
  49. kill "$SSHD_PID"
  50. SSHD_PID=
  51. set -e
  52. echo "##### return $RETURN"
  53. if [ "$RETURN" = "$CODE" ] ; then
  54. echo "##### ssh connection test returned as desired"
  55. return 0
  56. else
  57. echo "##### ssh connection test failed. expected return code $CODE"
  58. return 1
  59. fi
  60. }
  61. SSHD_PID=
  62. ## setup trap
  63. trap failed_cleanup EXIT
  64. ######################################################################
  65. ### SETUP VARIABLES
  66. ## set up some variables to ensure that we're operating strictly in
  67. ## the tests, not system-wide:
  68. # make temp dir
  69. # FIXME: I believe that /tmp can not be used as the temp dir here,
  70. # since the permissions on /tmp are usually such that they will not
  71. # pass the monkeysphere/ssh path permission checking. at least this
  72. # is my experience.
  73. #TEMPDIR=$(mktemp -d "${TMPDIR:-$TESTDIR/tmp}/monkeyspheretest.XXXXXXX")
  74. TEMPDIR=$(mktemp -d "${TESTDIR}/tmp/monkeyspheretest.XXXXXXX")
  75. # Use the local copy of executables first, instead of system ones.
  76. # This should help us test without installing.
  77. export PATH="$TESTDIR"/../src:"$TESTDIR"/../src/keytrans:"$PATH"
  78. export MONKEYSPHERE_SYSDATADIR="$TEMPDIR"
  79. export MONKEYSPHERE_SYSCONFIGDIR="$TEMPDIR"
  80. export MONKEYSPHERE_SYSSHAREDIR="$TESTDIR"/../src/share
  81. export MONKEYSPHERE_MONKEYSPHERE_USER=$(whoami)
  82. export MONKEYSPHERE_CHECK_KEYSERVER=false
  83. export MONKEYSPHERE_LOG_LEVEL=DEBUG
  84. export MONKEYSPHERE_CORE_KEYLENGTH=1024
  85. export SSHD_CONFIG="$TEMPDIR"/sshd_config
  86. export SOCKET="$TEMPDIR"/ssh-socket
  87. # Make sure $DISPLAY is set to convince ssh and monkeysphere to fall
  88. # back on $SSH_ASKPASS. Make sure it's not set to the current actual
  89. # $DISPLAY (if one exists) because this test suite should not be doing
  90. # *anything* with any running X11 session.
  91. export DISPLAY=monkeys
  92. ######################################################################
  93. ### CONFIGURE ENVIRONMENTS
  94. # copy in admin and testuser home to tmp
  95. echo "##################################################"
  96. echo "### configuring testuser home..."
  97. cp -a "$TESTDIR"/home/testuser "$TEMPDIR"/
  98. # set up environment for testuser
  99. export TESTHOME="$TEMPDIR"/testuser
  100. export GNUPGHOME="$TESTHOME"/.gnupg
  101. chmod 0700 "$GNUPGHOME"
  102. export SSH_ASKPASS="$TESTHOME"/.ssh/askpass
  103. export MONKEYSPHERE_HOME="$TESTHOME"/.monkeysphere
  104. cat <<EOF >> "$TESTHOME"/.ssh/config
  105. UserKnownHostsFile $TESTHOME/.ssh/known_hosts
  106. IdentityFile $TESTHOME/.ssh/no-such-identity
  107. ProxyCommand $TESTHOME/.ssh/proxy-command %h %p $SOCKET
  108. EOF
  109. cat <<EOF >> "$MONKEYSPHERE_HOME"/monkeysphere.conf
  110. KNOWN_HOSTS=$TESTHOME/.ssh/known_hosts
  111. EOF
  112. get_gpg_prng_arg >> "$GNUPGHOME"/gpg.conf
  113. echo "##################################################"
  114. echo "### configuring admin home..."
  115. cp -a "$TESTDIR"/home/admin "$TEMPDIR"/
  116. # set up sshd
  117. echo "##################################################"
  118. echo "### configuring sshd..."
  119. cp "$TESTDIR"/etc/ssh/sshd_config "$SSHD_CONFIG"
  120. # write the sshd_config
  121. cat <<EOF >> "$SSHD_CONFIG"
  122. HostKey ${MONKEYSPHERE_SYSDATADIR}/ssh_host_rsa_key
  123. AuthorizedKeysFile ${MONKEYSPHERE_SYSDATADIR}/authentication/authorized_keys/%u
  124. EOF
  125. ######################################################################
  126. ### SERVER HOST SETUP
  127. # import host key
  128. echo "##################################################"
  129. echo "### testing host key importing..."
  130. ssh-keygen -b 1024 -t rsa -N '' -f "$TEMPDIR"/ssh_host_rsa_key
  131. monkeysphere-host expert import-key testhost < "$TEMPDIR"/ssh_host_rsa_key
  132. # change host key expiration
  133. echo "##################################################"
  134. echo "### setting host key expiration..."
  135. monkeysphere-host set-expire 1
  136. monkeysphere-host show-key
  137. # FIXME: how do we check that the expiration has really been set?
  138. echo "##################################################"
  139. echo "### getting host key fingerprint..."
  140. HOSTKEYID=$( monkeysphere-host show-key | grep '^OpenPGP fingerprint: ' | cut -f3 -d\ )
  141. echo "$HOSTKEYID"
  142. # certify host key with the "Admin's Key".
  143. # (this would normally be done via keyservers)
  144. echo "##################################################"
  145. echo "### certifying server host key..."
  146. GNUPGHOME="$MONKEYSPHERE_SYSCONFIGDIR"/host gpg --armor --export "$HOSTKEYID" | gpgadmin --import
  147. echo y | gpgadmin --command-fd 0 --sign-key "$HOSTKEYID"
  148. # FIXME: add revoker?
  149. # FIXME: how can we test publish-key without flooding junk into the
  150. # keyservers?
  151. # FIXME: should we run "diagnostics" here to test setup?
  152. ######################################################################
  153. ### SERVER AUTHENTICATION SETUP
  154. # set up monkeysphere authentication
  155. echo "##################################################"
  156. echo "### setup monkeysphere authentication..."
  157. cp "$TESTDIR"/etc/monkeysphere/monkeysphere-authentication.conf "$TEMPDIR"/
  158. cat <<EOF >> "$TEMPDIR"/monkeysphere-authentication.conf
  159. AUTHORIZED_USER_IDS="$MONKEYSPHERE_HOME/authorized_user_ids"
  160. EOF
  161. monkeysphere-authentication setup
  162. get_gpg_prng_arg >> "$MONKEYSPHERE_SYSDATADIR"/authentication/sphere/gpg.conf
  163. # add admin as identity certifier for testhost
  164. echo "##################################################"
  165. echo "### adding admin as certifier..."
  166. monkeysphere-authentication add-id-certifier -y "$TEMPDIR"/admin/.gnupg/pubkey.gpg
  167. # FIXME: should we run "diagnostics" here to test setup?
  168. ######################################################################
  169. ### TESTUSER SETUP
  170. # generate an auth subkey for the test user that expires in 2 days
  171. echo "##################################################"
  172. echo "### generating key for testuser..."
  173. monkeysphere gen-subkey --expire 2
  174. # add server key to testuser keychain
  175. echo "##################################################"
  176. echo "### export server key to testuser..."
  177. gpgadmin --armor --export "$HOSTKEYID" | gpg --import
  178. # teach the "server" about the testuser's key
  179. echo "##################################################"
  180. echo "### export testuser key to server..."
  181. gpg --export testuser | monkeysphere-authentication expert gpg-cmd --import
  182. # update authorized_keys for user
  183. echo "##################################################"
  184. echo "### update server authorized_keys file for this testuser..."
  185. monkeysphere-authentication update-users $(whoami)
  186. # FIXME: NOT FAILING PROPERLY FOR:
  187. # ms: improper group or other writability on path '/tmp'.
  188. ######################################################################
  189. ### TESTS
  190. # connect to test sshd, using monkeysphere ssh-proxycommand to verify
  191. # the identity before connection. This should work in both directions!
  192. echo "##################################################"
  193. echo "### ssh connection test for success..."
  194. ssh_test
  195. # remove the testuser's authorized_user_ids file, update, and make
  196. # sure that the ssh authentication FAILS
  197. echo "##################################################"
  198. echo "### removing testuser authorized_user_ids and updating..."
  199. mv "$TESTHOME"/.monkeysphere/authorized_user_ids{,.bak}
  200. monkeysphere-authentication update-users $(whoami)
  201. echo "##################################################"
  202. echo "### ssh connection test for server authentication denial..."
  203. ssh_test 255
  204. mv "$TESTHOME"/.monkeysphere/authorized_user_ids{.bak,}
  205. # put improper permissions on authorized_user_ids file, update, and
  206. # make sure ssh authentication FAILS
  207. echo "##################################################"
  208. echo "### setting group writability on authorized_user_ids and updating..."
  209. chmod g+w "$TESTHOME"/.monkeysphere/authorized_user_ids
  210. monkeysphere-authentication update-users $(whoami)
  211. echo "##################################################"
  212. echo "### ssh connection test for server authentication denial..."
  213. ssh_test 255
  214. chmod g-w "$TESTHOME"/.monkeysphere/authorized_user_ids
  215. echo "##################################################"
  216. echo "### setting other writability on authorized_user_ids and updating..."
  217. chmod o+w "$TESTHOME"/.monkeysphere/authorized_user_ids
  218. monkeysphere-authentication update-users $(whoami)
  219. echo "##################################################"
  220. echo "### ssh connection test for server authentication denial..."
  221. ssh_test 255
  222. chmod o-w "$TESTHOME"/.monkeysphere/authorized_user_ids
  223. # FIXME: addtest: remove admin as id-certifier and check ssh failure
  224. # FIXME: addtest: add hostname on host key
  225. # FIXME: addtest: revoke hostname on host key and check ssh failure
  226. # FIXME: addtest: revoke the host key and check ssh failure
  227. ######################################################################
  228. trap - EXIT
  229. echo "##################################################"
  230. echo " Monkeysphere basic tests completed successfully!"
  231. echo "##################################################"
  232. cleanup